//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Collapse.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
/*
This program collapses all the Z components of
a DXF file to the Z = 0 plane.
Also all normals are set to the default figure & all extrusions are set to zero.

Last updated 29 Apr 2002
*/
TCollapseForm *CollapseForm;
//---------------------------------------------------------------------------
__fastcall TCollapseForm::TCollapseForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TCollapseForm::Button2Click(TObject *Sender)
{
    if (OpenDialog1->Execute()) {
        Edit1->Text = OpenDialog1->FileName;
        OpenDialog1->InitialDir = ExtractFilePath(Edit1->Text);
        Edit2->Text = ChangeFileExt(Edit1->Text, " Collapsed.dxf");
        SaveDialog1->InitialDir = ExtractFilePath(Edit1->Text);
        }
}
//---------------------------------------------------------------------------

void __fastcall TCollapseForm::Button3Click(TObject *Sender)
{
    if (SaveDialog1->Execute()) {
        Edit2->Text = SaveDialog1->FileName;
        SaveDialog1->InitialDir = ExtractFilePath(Edit2->Text);
        }

}
//---------------------------------------------------------------------------
void __fastcall TCollapseForm::Button1Click(TObject *Sender)
{
    if (!Edit1->Text.Length() || !Edit2->Text.Length()) {
        Application->MessageBox("Need two file names\n\nConversion Aborted.","Warning", MB_OK | MB_ICONERROR);
        Label3->Caption = "Conversion Aborted";
        return;
        }

    if (Edit1->Text.LowerCase() == Edit2->Text.LowerCase()) {
        Application->MessageBox("Both file names the same\n\nConversion Aborted.","Warning", MB_OK | MB_ICONERROR);
        Label3->Caption = "Conversion Aborted";
        return;
        }

    if (FileExists(Edit1->Text) && !FileExists(Edit2->Text)) {
        try {
            Button1->Enabled = false;
            Button2->Enabled = false;
            Button3->Enabled = false;
            Button4->Enabled = false;
            Button5->Enabled = false;
            Edit1->Enabled = false;
            Edit2->Enabled = false;
            Refresh();

            TStringList *DXFFile = new TStringList();
            Label3->Caption = "Opening File";
            Refresh();
            DXFFile->LoadFromFile(Edit1->Text);
            Label3->Caption = "Sorting File";
            Refresh();

            int counter = 0;
            int filelength = DXFFile->Count;
            AnsiString temp;
            int value;

            while (counter < filelength) {
                if (!(counter % 1000)) {
                    Label3->Caption = "Line " + AnsiString(counter) + " of " + AnsiString(filelength);
                    if (!(counter %10000)) {
                        Refresh();
                        } else {
                        Label3->Refresh();
                        }
                    }
                temp = DXFFile->Strings[counter];
                temp = temp.Trim();
                value = temp.ToIntDef(0);
                switch (value) {
                    case 210:   //Normal X Direction
                    case 220:   //Normal Y Direction
                    case 39:    //Extrusion Thickness
                    case 38:    //Z co-ordinate
                    case 37:    // "
                    case 36:    // "
                    case 35:    // "
                    case 34:    // "
                    case 33:    // "
                    case 32:    // "
                    case 31:    // "
                    case 30:    {       // "
                                DXFFile->Strings[counter + 1] = "0.0";
                                }
                                break;
                    case 230:   {       //Normal Z Direction
                                DXFFile->Strings[counter + 1] = "1.0";
                                }
                                break;
                    default:    break;
                    }
                counter += 2;
                }
            Label3->Caption = "Saving File";
            Refresh();

            DXFFile->SaveToFile(Edit2->Text);

            Label3->Caption = "Clearing Memory";
            Refresh();

            delete DXFFile;

            Label3->Caption = "Finished";
            Refresh();
            }

        __finally {
            Button1->Enabled = true;
            Button2->Enabled = true;
            Button3->Enabled = true;
            Button4->Enabled = true;
            Button5->Enabled = true;
            Edit1->Enabled = true;
            Edit2->Enabled = true;
            Refresh();
            }

        } else {
        if (FileExists(Edit1->Text)) {
            Application->MessageBox("An existing converted file will get overwritten.\n\nPlease delete file or change converted file name","Warning", MB_OK | MB_ICONERROR);
            } else {
            Application->MessageBox("The input file does not exist.\n\nPlease check","Warning", MB_OK | MB_ICONERROR);
            }
        Label3->Caption = "Conversion Aborted";
        }
}
//---------------------------------------------------------------------------
void __fastcall TCollapseForm::Button4Click(TObject *Sender)
{
    Application->MessageBox("This program takes a DXF File, and collapses\nall the Z co-ordinates to 0.0.\nAll Circle/ Arc/ Extrusion Normals are set to 0,0,1 and\nall Extrusion Thicknesses are set to 0.0.\n\nTo operate, select 2 file names and press the\n'collapse' button.\n","Help on DXF Z Collapse Program",MB_OK | MB_ICONINFORMATION);
}
//---------------------------------------------------------------------------

void __fastcall TCollapseForm::Button5Click(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------

